#ifndef CAMERA_H_
#define CAMERA_H_

#include "vmath.h"
#include "snode.h"

class Camera : public SceneNode {
private:
	SceneNode target;
	float fov;

	void calc_matrix() const;

public:
	Camera();

	void set_target(const Vector3 &target);
	Vector3 get_target() const;

	void set_fov(float fov);
	float get_fov() const;

	void draw(bool emph = false) const;

	bool intersect(const Ray &ray, RayHit *hit = 0) const;

	Ray get_primary_ray(int x, int y) const;
};

#endif	// CAMERA_H_
