#ifndef LIGHT_H_
#define LIGHT_H_

#include "vmath.h"
#include "snode.h"

class Light : public SceneNode {
private:
	float intens;
	Vector3 color;
	Vector3 atten;

public:
	Light();

	void set_intensity(float val);
	float get_intensity() const;

	void set_color(const Vector3 &color);
	const Vector3 &get_color() const;

	// includes attenuation and intensity
	Vector3 get_color(const Vector3 &pt) const;

	void set_attenuation(const Vector3 &atten);
	const Vector3 &get_attenuation() const;

	float calc_attenuation(float d) const;

	void draw(bool emph = false) const;

	bool intersect(const Ray &ray, RayHit *hit = 0) const;
};

#endif	// LIGHT_H_
