#ifndef M3DIMPL_H_
#define M3DIMPL_H_

#include "min3d.h"

#define MSTACK_SIZE		16

struct min3d_mstack {
	float m[MSTACK_SIZE][16];
	int top;
};

struct min3d_vertex {
	float pos[4];
	uint32_t color;
	float normal[4];
	float tex[2];
};

#define IM_VBSIZE	4

struct min3d_context {
	struct m3d_image *cbuf;
	uint16_t *zbuf;

	unsigned long state;
	int clear_color[3];

	int mmode;	/* matrix mode */
	struct min3d_mstack mstack[2];

	int vport[4];

	float *vert_array;
	float *norm_array;
	float *col_array;
	float *tc_array;

	/* immediate mode state */
	float im_varr[IM_VBSIZE * 3];
	float im_narr[IM_VBSIZE * 3];
	float im_carr[IM_VBSIZE * 3];
	float im_tarr[IM_VBSIZE * 2];

	int im_prim, im_idx;
	float im_color[4];
	float im_normal[3];
	float im_texcoord[2];
};

extern struct min3d_context *m3dctx;

#define ENABLED(x)	(m3dctx->state & (1 << x))

void m3d_draw_point(struct min3d_vertex *v);
void m3d_draw_line(struct min3d_vertex *v);
void m3d_draw_poly(struct min3d_vertex *v, int numv);

#endif	/* M3DIMPL_H_ */
