#include "m3dimpl.h"
#include "lines.h"


void m3d_draw_point(struct min3d_vertex *v)
{
	int x = v->pos[0] + 0.5;
	int y = v->pos[1] + 0.5;
	int xsz = m3dctx->cbuf->xsz;
	m3dctx->cbuf->pixels[y * xsz + x] = v->color;
}

void m3d_draw_line(struct min3d_vertex *v)
{
	int x0, y0, x1, y1;

	x0 = v[0].pos[0];
	y0 = v[0].pos[1];
	x1 = v[1].pos[0];
	y1 = v[1].pos[1];

	if(clip_line2d(&x0, &y0, &x1, &y1, m3dctx->vport)) {
		draw_line(m3dctx->cbuf->pixels, m3dctx->cbuf->xsz, v->color, x0, y0, x1, y1);
	}
}

void m3d_draw_poly(struct min3d_vertex *v, int numv)
{
	int i;
	struct min3d_vertex last[2];

	if(ENABLED(M3D_CULL_FACE)) {
		float a[2], b[2], crossz = 0;

		for(i=1; i<numv - 1; i++) {
			int n = i + 1;
			a[0] = v[i].pos[0] - v[0].pos[0];
			a[1] = v[i].pos[1] - v[0].pos[1];

			b[0] = v[n].pos[0] - v[0].pos[0];
			b[1] = v[n].pos[1] - v[0].pos[1];

			crossz += a[0] * b[1] - a[1] * b[0];
		}

		if(crossz > 0) return;
	}

	last[0] = v[numv - 1];
	last[1] = v[0];

	for(i=0; i<numv - 1; i++) {
		m3d_draw_line(v++);
	}
	m3d_draw_line(last);
}
