#ifndef OBJECT_H_
#define OBJECT_H_

#include "vmath.h"
#include "snode.h"
#include "material.h"

class Object : public SceneNode {
public:
	Material mtl;

	Object();
	virtual ~Object();

	virtual Vector3 hit_normal(const RayHit &hit) const;
};

class Sphere : public Object {
public:
	Sphere();
	~Sphere();

	void draw(bool emph = false) const;

	bool intersect(const Ray &ray, RayHit *hit = 0) const;
	Vector3 hit_normal(const RayHit &hit) const;
};

class Box : public Object {
public:
	Box();
	~Box();

	void draw(bool emph = false) const;

	bool intersect(const Ray &ray, RayHit *hit = 0) const;
	Vector3 hit_normal(const RayHit &hit) const;
};

#endif	// OBJECT_H_
