#ifndef RAYTRACE_H_
#define RAYTRACE_H_

#include "vmath.h"
#include "vmathray.h"

class Object;

struct RayHit {
	Ray ray;			// the ray in world coordinates
	Ray lray;			// the local coordinate system ray
	float dist;			// parametric distance along the ray
	const Object *obj;	// pointer to the object that has been hit
	const void *subobj;	// object-specific subobject pointer (can be null).
};

Vector3 ray_trace(const Ray &ray, int iter = 0);
Vector3 shade(const RayHit &hit, int iter);

#endif	// RAYTRACE_H_
