#include <stdlib.h>
#include <string.h>
#include "screen.h"
#include "rbtree.h"
#include "logger.h"

MsgAtom message_atom(const char *str)
{
	static struct rbtree *atoms;
	static MsgAtom last_atom;
	struct rbnode *node;
	MsgAtom atom;

	if(!atoms) {
		if(!(atoms = rb_create(RB_KEY_STRING))) {
			printlog("fatal: message_atom failed to create symbol table\n");
			abort();
		}
	}

	if((node = rb_find(atoms, (void*)str))) {
		return *(MsgAtom*)&node->data;
	}

	atom = ++last_atom;
	if(rb_insert(atoms, (void*)str, (void*)atom) == -1) {
		printlog("message_atom failed to insert new atom\n");
		--last_atom;
		return -1;
	}
	return atom;
}

Screen::Screen()
{
	name = 0;
}

Screen::~Screen()
{
	delete [] name;
}

bool Screen::init()
{
	return true;
}

void Screen::shutdown()
{
}

void Screen::set_name(const char *name)
{
	delete [] this->name;
	this->name = new char[strlen(name) + 1];
	strcpy(this->name, name);
}

const char *Screen::get_name() const
{
	return name ? name : "<unnamed>";
}

void Screen::update()
{
}

void Screen::handle_keyboard(int key, bool press)
{
}

void Screen::handle_mbutton(int bn, bool press, int x, int y)
{
}

void Screen::handle_mmotion(int x, int y)
{
}

void Screen::message(MsgAtom msg, ...)
{
}
