#ifndef SCREEN_H_
#define SCREEN_H_

typedef int MsgAtom;

MsgAtom message_atom(const char *str);

class Screen {
private:
	char *name;

public:
	Screen();
	virtual ~Screen();

	virtual bool init();
	virtual void shutdown();

	virtual void set_name(const char *name);
	virtual const char *get_name() const;

	virtual void update();
	virtual void draw() const = 0;

	virtual void handle_keyboard(int key, bool press);
	virtual void handle_mbutton(int bn, bool press, int x, int y);
	virtual void handle_mmotion(int x, int y);

	virtual void message(MsgAtom msg, ...);
};

#endif	// SCREEN_H_
