#include <string.h>
#include "vector.h"
#include "scrman.h"

static vector<Screen*> screens;
static vector<Screen*> active;

void add_screen(Screen *s)
{
	screens.push_back(s);
}

Screen *get_screen(const char *name)
{
	for(size_t i=0; i<screens.size(); i++) {
		if(strcmp(screens[i]->get_name(), name) == 0) {
			return screens[i];
		}
	}
	return 0;
}

void destroy_screens()
{
	for(size_t i=0; i<screens.size(); i++) {
		screens[i]->shutdown();
		delete screens[i];
	}
	screens.clear();
	active.clear();
}

void activate_screen(Screen *s)
{
	active.push_back(s);
}

Screen *deactivate_screen()
{
	Screen *s = active_screen();
	if(!s) return 0;

	active.pop_back();
	return s;
}

Screen *active_screen()
{
	return active.empty() ? 0 : active.back();
}
