; vim:set ft=nasm:
	segment code use32

	; void swap_buffers_asm(void *dest, void *src, int xsz, int ysz, int bpp)
	; dest	-> eax
	; src	-> edx
	; xsz	-> ebx
	; ysz	-> ecx
	; bpp	-> [ebp + 8] (after pushing ebp)
	global swap_buffers_asm_
swap_buffers_asm_:
	push ebp
	mov ebp, esp

	mov edi, eax	; let's hold dest ptr in edi, frees up eax
	mov esi, edx	; let's hold src ptr in esi, frees up edx
	; calculate pixel count -> ecx, frees up ebx
	mov eax, ebx
	mul ecx
	mov ecx, eax	; now ecx = xsz * ysz	
	
	mov eax, [ebp + 8]	; eax <- bpp
	cmp eax, 32
	je .bpp32
	cmp eax, 24
	je .bpp24
	cmp eax, 16
	je .bpp16
	; invalid bpp, ignore
	jmp .done

.bpp32:				; 32bit block transfer, no conversion
	rep movsd		; esi, edi, and ecx already loaded, just go...
	jmp .done
	
.bpp24:				; 32bpp -> 24bpp conversion (LSB-first), 1 byte overrun!
	movsd			; transfer a full 32bit chunk and inc esi,edi by 4
	dec edi			; backtrack dest one byte after last transfer
	dec ecx
	jnz .bpp24
	jmp .done

.bpp16:				; fuck 16bpp for now (TODO)
.done:
	pop ebp
	ret	
