/*
pit8254 timer code for DOS programs.
Copyright (C) 2011-2014  John Tsiombikas <nuclear@member.fsf.org>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef TIMER_H_
#define TIMER_H_

#ifdef __cplusplus
extern "C" {
#endif

/* expects the required timer resolution in hertz
 * if res_hz is 0, the current resolution is retained
 */
void init_timer(int res_hz);

void reset_timer(void);
unsigned long get_msec(void);
unsigned long get_ticks(void);

#ifdef __cplusplus
}
#endif

#endif	/* TIMER_H_ */
