#ifndef VMATH_RAY_H_
#define VMATH_RAY_H_

#include "vmath.h"
#include "vmathmat.h"

class Ray {
public:
	Vector3 origin, dir;

	Ray() {}
	Ray(const Vector3 &p, const Vector3 &d) : origin(p), dir(d) {}
};

inline Ray transform(const Matrix4x4 &m, const Ray &r)
{
	Matrix4x4 rmat = m;
	rmat[0][3] = rmat[1][3] = rmat[2][3] = rmat[3][0] = rmat[3][1] = rmat[3][2] = 0.0;
	rmat[3][3] = 1.0;

	return Ray(transform(m, r.origin), transform(rmat, r.dir));
}

#endif	// VMATH_RAY_H_
